import { DVCClient as Client, DVCFeatureSet, DVCOptions, DVCVariableSet, DVCVariableValue, DVCEvent as ClientEvent, DVCUser, ErrorCallback } from './types';
import { DVCVariable } from './Variable';
import Store from './Store';
import { DVCPopulatedUser } from './User';
import { EventQueue } from './EventQueue';
import { EventEmitter } from './EventEmitter';
import { BucketedUserConfig } from '@devcycle/types';
import { RequestConsolidator } from './RequestConsolidator';
export declare class DVCClient implements Client {
    private options?;
    private onInitialized;
    private variableDefaultMap;
    private environmentKey;
    config?: BucketedUserConfig;
    user: DVCPopulatedUser;
    store: Store;
    eventQueue: EventQueue;
    requestConsolidator: RequestConsolidator;
    eventEmitter: EventEmitter;
    constructor(environmentKey: string, user: DVCPopulatedUser, options?: DVCOptions);
    onClientInitialized(): Promise<DVCClient>;
    onClientInitialized(onInitialized: ErrorCallback<DVCClient>): void;
    variable(key: string, defaultValue: DVCVariableValue): DVCVariable;
    identifyUser(user: DVCUser): Promise<DVCVariableSet>;
    identifyUser(user: DVCUser, callback?: ErrorCallback<DVCVariableSet>): void;
    resetUser(): Promise<DVCVariableSet>;
    resetUser(callback: ErrorCallback<DVCVariableSet>): void;
    allFeatures(): DVCFeatureSet;
    allVariables(): DVCVariableSet;
    subscribe(key: string, handler: (...args: any[]) => void): void;
    unsubscribe(key: string, handler?: (...args: any[]) => void): void;
    track(event: ClientEvent): void;
    flushEvents(callback?: () => void): Promise<void>;
}
