import { BucketedUserConfig } from '@devcycle/types';
import { DVCPopulatedUser } from './User';
export declare const StoreKey: {
    Config: string;
    User: string;
    AnonUser: string;
};
export declare class Store {
    store?: Storage;
    constructor(localStorage: Storage);
    save(storeKey: string, data: unknown): Promise<void>;
    load(storeKey: string): Promise<string | null | undefined>;
    clear(storeKey: string): Promise<void>;
    modifyStore(modify: (storeKey: string) => void, storeKey: string): Promise<void>;
    saveConfig(data: BucketedUserConfig): Promise<void>;
    loadConfig(): Promise<string | null | undefined>;
    saveUser(user: DVCPopulatedUser): Promise<void>;
    loadUser(): Promise<string | null | undefined>;
}
export default Store;
